/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { SizableComponentSize_$type } from "./SizableComponentSize";
import { ComponentValueChangedEventArgs } from "./ComponentValueChangedEventArgs";
import { VoidEventArgs } from "./VoidEventArgs";
import { InputBaseDirection_$type } from "./InputBaseDirection";
import { InputBaseSelectMode_$type } from "./InputBaseSelectMode";
/**
 * @hidden
 */
export let InputBase = /*@__PURE__*/ (() => {
    class InputBase extends BaseElement {
        constructor() {
            super(...arguments);
            this.f = new WCNativeHelper();
            this.n = null;
            this.inputOcurred = null;
            this.focus = null;
            this.blur = null;
        }
        get g() {
            return this.f;
        }
        get nativeElement() {
            return this.n;
        }
        set nativeElement(a) {
            this.n = a;
            this.f.o = this.n;
        }
        setNativeElement(a) {
            this.nativeElement = a;
        }
        get j() {
            let ret_ = this.g.n("outlined");
            return ret_;
        }
        set j(a) {
            let value_ = a;
            this.g.v("outlined", value_);
        }
        get l() {
            let ret_ = this.g.n("readOnly");
            return ret_;
        }
        set l(a) {
            let value_ = a;
            this.g.v("readOnly", value_);
        }
        get k() {
            let ret_ = this.g.n("readonly");
            return ret_;
        }
        set k(a) {
            let value_ = a;
            this.g.v("readonly", value_);
        }
        get r() {
            let ret_ = this.g.n("placeholder");
            return ret_;
        }
        set r(a) {
            let value_ = a;
            this.g.v("placeholder", value_);
        }
        get p() {
            let ret_ = this.g.n("label");
            return ret_;
        }
        set p(a) {
            let value_ = a;
            this.g.v("label", value_);
        }
        get c() {
            let ret_ = this.g.n("size");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SizableComponentSize_$type, EnumUtil.getEnumValue(SizableComponentSize_$type, this.g.f(SizableComponentSize_$type, ret_)));
            return EnumUtil.getEnumValue(SizableComponentSize_$type, ret_);
        }
        set c(a) {
            let value_ = enumGetBox(SizableComponentSize_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.g.v("size", value_);
        }
        get h() {
            let ret_ = this.g.n("disabled");
            return ret_;
        }
        set h(a) {
            let value_ = a;
            this.g.v("disabled", value_);
        }
        get m() {
            let ret_ = this.g.n("required");
            return ret_;
        }
        set m(a) {
            let value_ = a;
            this.g.v("required", value_);
        }
        get q() {
            let ret_ = this.g.n("name");
            return ret_;
        }
        set q(a) {
            let value_ = a;
            this.g.v("name", value_);
        }
        get i() {
            let ret_ = this.g.n("invalid");
            return ret_;
        }
        set i(a) {
            let value_ = a;
            this.g.v("invalid", value_);
        }
        inputOcurredChanged() {
            if (this.inputOcurred != null) {
                this.g.r("input", (a) => this.inputOcurred(this, ComponentValueChangedEventArgs.a(a)));
            }
            else {
                this.g.u("input");
            }
        }
        focusChanged() {
            if (this.focus != null) {
                this.g.r("focus", (a) => this.focus(this, VoidEventArgs.b(a)));
            }
            else {
                this.g.u("focus");
            }
        }
        blurChanged() {
            if (this.blur != null) {
                this.g.r("blur", (a) => this.blur(this, VoidEventArgs.b(a)));
            }
            else {
                this.g.u("blur");
            }
        }
        v() {
            this.nativeElement.connectedCallback();
        }
        w() {
            this.nativeElement.disconnectedCallback();
        }
        y(a) {
            this.nativeElement.focus(this.g.i(a));
        }
        t() {
            this.nativeElement.blur();
        }
        ae(a, b, c) {
            this.nativeElement.setSelectionRange(this.g.i(a), this.g.i(b), this.g.i(enumGetBox(InputBaseDirection_$type, c)));
        }
        ad(a, b, c, d) {
            this.nativeElement.setRangeText(this.g.i(a), this.g.i(b), this.g.i(c), this.g.i(enumGetBox(InputBaseSelectMode_$type, d)));
        }
        aa() {
            this.nativeElement.reportValidity();
        }
        u() {
            this.nativeElement.checkValidity();
        }
        ab(a) {
            this.nativeElement.setCustomValidity(this.g.i(a));
        }
    }
    InputBase.$t = /*@__PURE__*/ markType(InputBase, 'InputBase', BaseElement.$);
    InputBase.__marshalByValueIgnore = ["readonly"];
    return InputBase;
})();
