/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BaseElement } from "./BaseElement";
import { WCNativeHelper } from "./WCNativeHelper";
import { enumGetBox, EnumUtil, markType } from "igniteui-react-core";
import { TreeSelection_$type } from "./TreeSelection";
import { SizableComponentSize_$type } from "./SizableComponentSize";
import { TreeSelectionChangeEventArgs } from "./TreeSelectionChangeEventArgs";
import { TreeItemComponentEventArgs } from "./TreeItemComponentEventArgs";
/**
 * @hidden
 */
var Tree = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Tree, _super);
    function Tree() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.i = new WCNativeHelper();
        _this.m = null;
        _this.selectionChanged = null;
        _this.itemExpanding = null;
        _this.itemExpanded = null;
        _this.itemCollapsing = null;
        _this.itemCollapsed = null;
        _this.activeItem = null;
        return _this;
    }
    Object.defineProperty(Tree.prototype, "j", {
        get: function () {
            return this.i;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tree.prototype, "nativeElement", {
        get: function () {
            return this.m;
        },
        set: function (a) {
            this.m = a;
            this.i.o = this.m;
        },
        enumerable: false,
        configurable: true
    });
    Tree.prototype.setNativeElement = function (a) {
        this.nativeElement = a;
    };
    Object.defineProperty(Tree.prototype, "k", {
        get: function () {
            var ret_ = this.j.n("singleBranchExpand");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.j.v("singleBranchExpand", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tree.prototype, "l", {
        get: function () {
            var ret_ = this.j.n("toggleNodeOnClick");
            return ret_;
        },
        set: function (a) {
            var value_ = a;
            this.j.v("toggleNodeOnClick", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tree.prototype, "g", {
        get: function () {
            var ret_ = this.j.n("selection");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(TreeSelection_$type, EnumUtil.getEnumValue(TreeSelection_$type, this.j.f(TreeSelection_$type, ret_)));
            return EnumUtil.getEnumValue(TreeSelection_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(TreeSelection_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.j.v("selection", value_);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Tree.prototype, "a", {
        get: function () {
            var ret_ = this.j.n("size");
            if ((ret_ === undefined && this.___rawMode)) {
                return undefined;
            }
            ret_ = enumGetBox(SizableComponentSize_$type, EnumUtil.getEnumValue(SizableComponentSize_$type, this.j.f(SizableComponentSize_$type, ret_)));
            return EnumUtil.getEnumValue(SizableComponentSize_$type, ret_);
        },
        set: function (a) {
            var value_ = enumGetBox(SizableComponentSize_$type, a);
            value_ = WCNativeHelper.camel(value_.toString());
            this.j.v("size", value_);
        },
        enumerable: false,
        configurable: true
    });
    Tree.prototype.selectionChangedChanged = function () {
        var _this = this;
        if (this.selectionChanged != null) {
            this.j.r("selection", function (a) { return _this.selectionChanged(_this, TreeSelectionChangeEventArgs.b(a)); });
        }
        else {
            this.j.u("selection");
        }
    };
    Tree.prototype.itemExpandingChanged = function () {
        var _this = this;
        if (this.itemExpanding != null) {
            this.j.r("itemExpanding", function (a) { return _this.itemExpanding(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.j.u("itemExpanding");
        }
    };
    Tree.prototype.itemExpandedChanged = function () {
        var _this = this;
        if (this.itemExpanded != null) {
            this.j.r("itemExpanded", function (a) { return _this.itemExpanded(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.j.u("itemExpanded");
        }
    };
    Tree.prototype.itemCollapsingChanged = function () {
        var _this = this;
        if (this.itemCollapsing != null) {
            this.j.r("itemCollapsing", function (a) { return _this.itemCollapsing(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.j.u("itemCollapsing");
        }
    };
    Tree.prototype.itemCollapsedChanged = function () {
        var _this = this;
        if (this.itemCollapsed != null) {
            this.j.r("itemCollapsed", function (a) { return _this.itemCollapsed(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.j.u("itemCollapsed");
        }
    };
    Tree.prototype.activeItemChanged = function () {
        var _this = this;
        if (this.activeItem != null) {
            this.j.r("activeItem", function (a) { return _this.activeItem(_this, TreeItemComponentEventArgs.b(a)); });
        }
        else {
            this.j.u("activeItem");
        }
    };
    Tree.prototype.p = function () {
        this.nativeElement.connectedCallback();
    };
    Tree.prototype.q = function (a) {
        this.nativeElement.expandToItem(this.j.i(a));
    };
    Tree.$t = markType(Tree, 'Tree', BaseElement.$);
    return Tree;
}(BaseElement));
export { Tree };
