import { __extends } from "tslib";
import * as React from 'react';
import { IgrBaseAlertLike } from "./igr-base-alert-like";
import { Toast } from "./Toast";
import { IgcToastComponent, defineComponents } from "igniteui-webcomponents";
/**
 * A toast component is used to show a notification
*/
var IgrToast = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgrToast, _super);
    function IgrToast(props) {
        var _this = _super.call(this, props) || this;
        _this._getMainRef = _this._getMainRef.bind(_this);
        defineComponents(IgcToastComponent);
        return _this;
    }
    IgrToast.prototype.createImplementation = function () {
        return new Toast();
    };
    Object.defineProperty(IgrToast.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgrToast.prototype.componentDidMount = function () {
        this.i.nativeElement = this._elRef;
        this.mounted = true;
        _super.prototype.componentDidMount.call(this);
    };
    IgrToast.prototype.render = function () {
        var propChildren = this.props.children;
        var children = [];
        React.Children.forEach(propChildren, function (ch) {
            children.push(React.cloneElement(ch));
        });
        this._portalManager.onRender(children);
        var style = {};
        if (this.props.style) {
            style = this.props.style;
        }
        var div = React.createElement("igc-toast", {
            ref: this._getMainRef,
            id: this.props.id,
            class: this.props.className,
            style: style,
            children: children
        });
        return div;
    };
    IgrToast.prototype._getMainRef = function (ref) {
        this._elRef = ref;
    };
    return IgrToast;
}(IgrBaseAlertLike));
export { IgrToast };
