import * as React from 'react';
import { Card } from "./Card";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * A container which wraps different elements related to a single subject
*/
export declare class IgrCard<P extends IIgrCardProps = IIgrCardProps> extends React.Component<P, {}> {
    protected createImplementation(): Card;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): Card; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrCard;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: P["id"];
        class: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * Sets card elevated style, otherwise card looks outlined.
    */
    get elevated(): boolean;
    set elevated(v: boolean);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrCardProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    /**
     * Sets card elevated style, otherwise card looks outlined.
    */
    elevated?: boolean | string;
}
