import * as React from 'react';
import { SizableComponentSize } from "./SizableComponentSize";
import { List } from "./List";
import { ReactRenderer, PortalManager } from "igniteui-react-core";
import { ContentChildrenManager } from "igniteui-react-core";
/**
 * Displays a collection of data items in a templatable list format.
*/
export declare class IgrList<P extends IIgrListProps = IIgrListProps> extends React.Component<P, {}> {
    protected createImplementation(): List;
    protected _implementation: any;
    protected mounted: boolean;
    /**
     * @hidden
     */
    get i(): List; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgrList;
    protected _renderer: ReactRenderer;
    protected _portalManager: PortalManager;
    protected onImplementationCreated(): void;
    protected _contentChildrenManager: ContentChildrenManager;
    constructor(props: P);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    render(): React.DOMElement<{
        ref: (ref: any) => void;
        id: P["id"];
        class: P["className"];
        style: P["style"];
        children: any[];
    }, any>;
    protected _elRef: HTMLElement;
    protected _getMainRef(ref: any): void;
    /**
     * @deprecated Use the `--ig-size` CSS custom property instead.
    */
    get size(): SizableComponentSize;
    set size(v: SizableComponentSize);
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    setNativeElement(element: any): void;
}
export interface IIgrListProps {
    children?: React.ReactNode;
    id?: string | undefined;
    className?: string | undefined;
    style?: React.CSSProperties | undefined;
    size?: SizableComponentSize | string;
}
